#ifndef BYTE_ORDER_CHANGER_H_
#define BYTE_ORDER_CHANGER_H_

#include "data_streamer.hpp" // @exclude

namespace sc {
    namespace io {
        class byte_order_changer {
            public:
                byte_order_changer(data_streamer* ds, byte_order order);
                ~byte_order_changer();

                byte_order_changer(byte_order_changer&& other);
                byte_order_changer& operator=(byte_order_changer&& other);

                byte_order_changer(const byte_order_changer&) = delete;
                byte_order_changer& operator=(const byte_order_changer&) = delete;

            private:
                data_streamer* _data_streamer {nullptr};
                byte_order _saved_byte_order {byte_order::undefined};
        };
    }
}

#endif // BYTE_ORDER_CHANGER_H_
