#ifndef FDIOBUF_H_
#define FDIOBUF_H_

#include <streambuf>

namespace sc {
    namespace io {
        class fdiobuf : public std::streambuf {
            public:
                fdiobuf(int fd) : _fd(fd) {}
                fdiobuf() : _fd(-1) {}

                int fd() const { return _fd; }
                void fd(int fd) { _fd = fd; }

            protected:
                int _fd;
                char _ch {};

                // input
                int_type underflow() override;
                std::streamsize xsgetn(char* s, std::streamsize n) override;

                // output
                int_type overflow(int_type c) override;
                std::streamsize xsputn(const char* s, std::streamsize num) override;

                // stream offset positioning
                pos_type seekoff(off_type off,
                                 std::ios_base::seekdir dir,
                                 std::ios_base::openmode which
                                 = std::ios_base::in | std::ios_base::out) override;
                pos_type seekpos(pos_type pos, std::ios_base::openmode which
                                 = std::ios_base::in | std::ios_base::out) override;
                int_type pbackfail(int_type c = EOF) override;
        };
    }
}

#endif // FDIOBUF_H_
